Deploy Review App:
  stage: Deploy
  image: registry.gitlab.com/commonground/core/review-app-deployer:latest
  script:
    - |
      kubectl config get-contexts
      kubectl config use-context delta10/clients/gemeente-utrecht-kaarten:review
    - |
      kubectl -n utrecht-kaarten-$CI_ENVIRONMENT_SLUG create secret docker-registry gitlab-registry \
      --docker-server=registry.gitlab.com \
      --docker-username=$REGISTRY_USERNAME \
      --docker-password=$REGISTRY_PASSWORD || true
    - |
      cd helm/
      helm upgrade --install utrecht-kaarten-$CI_ENVIRONMENT_SLUG . \
      --namespace utrecht-kaarten-$CI_ENVIRONMENT_SLUG \
      --create-namespace \
      --set image.repository=$CI_REGISTRY_IMAGE \
      --set image.tag=$CI_COMMIT_SHA \
      --set imagePullSecrets[0].name=gitlab-registry \
      --set ingress.hosts[0].host=utrecht-kaarten-$CI_ENVIRONMENT_SLUG.$REVIEW_BASE_DOMAIN \
      --set "ingress.hosts[0].paths[0].path=/" \
      --set "ingress.hosts[0].paths[0].pathType=ImplementationSpecific"

  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://utrecht-kaarten-$CI_ENVIRONMENT_SLUG.$REVIEW_BASE_DOMAIN
    on_stop: Remove Review App
  only:
    - branches@delta10/clients/gemeente-utrecht-kaarten
  except:
    - master@delta10/clients/gemeente-utrecht-kaarten

Remove Review App:
  stage: Deploy
  image: registry.gitlab.com/commonground/core/review-app-deployer:latest
  variables:
    GIT_STRATEGY: none
  script:
    - |
      kubectl config get-contexts
      kubectl config use-context delta10/clients/gemeente-utrecht-kaarten:review
    - kubectl delete namespace utrecht-kaarten-$CI_ENVIRONMENT_SLUG
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://utrecht-kaarten-$CI_ENVIRONMENT_SLUG.$REVIEW_BASE_DOMAIN
    action: stop
  only:
    - branches@delta10/clients/gemeente-utrecht-kaarten
  except:
    - master@delta10/clients/gemeente-utrecht-kaarten

Deploy acceptance:
  stage: Deploy
  image: registry.gitlab.com/commonground/core/review-app-deployer:latest
  script:
    - |
      kubectl config get-contexts
      kubectl config use-context delta10/clients/gemeente-utrecht-kaarten:review
    - |
      kubectl -n utrecht-kaarten-$CI_ENVIRONMENT_SLUG create secret docker-registry gitlab-registry \
      --docker-server=registry.gitlab.com \
      --docker-username=$REGISTRY_USERNAME \
      --docker-password=$REGISTRY_PASSWORD || true
    - |
      cd helm/
      helm upgrade --install utrecht-kaarten-$CI_ENVIRONMENT_SLUG . \
      --namespace utrecht-kaarten-$CI_ENVIRONMENT_SLUG \
      --create-namespace \
      --set image.repository=$CI_REGISTRY_IMAGE \
      --set image.tag=$CI_COMMIT_SHA \
      --set imagePullSecrets[0].name=gitlab-registry \
      --set ingress.hosts[0].host=utrecht-kaarten-$CI_ENVIRONMENT_SLUG.$REVIEW_BASE_DOMAIN \
      --set "ingress.hosts[0].paths[0].path=/" \
      --set "ingress.hosts[0].paths[0].pathType=ImplementationSpecific"
  environment:
    name: review/acc
    url: https://utrecht-kaarten-$CI_ENVIRONMENT_SLUG.$REVIEW_BASE_DOMAIN
  only:
    - master@delta10/clients/gemeente-utrecht-kaarten

Deploy Docker latest tag:
  stage: Deploy
  image: docker:19.03.12
  services:
    - docker:19.03.12-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  script:
    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - master
